Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.instruct
Class FixedAttribute

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.SimpleNodeConstructor
                  net.sf.saxon.instruct.FixedAttribute

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, TailCallReturner, InstructionInfoProvider

    public final class FixedAttribute

extends SimpleNodeConstructor

An instruction derived from an xsl:attribute element in stylesheet, or from an attribute constructor in XQuery. This version deals only with attributes whose name is known at compile time. It is also used for attributes of literal result elements. The value of the attribute is in general computed at run-time.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`FixedAttribute(int nameCode, int validationAction, SimpleType schemaType, int annotation)` Construct an Attribute instruction

Method Summary
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`void` | `display(int level, PrintStream out, Configuration config)` Display this instruction as an expression, for diagnostics
`Item` | `evaluateItem(XPathContext context)` Evaluate as an expression.
`int` | `evaluateNameCode(XPathContext context)`
`int` | `getCardinality()` Determine the static cardinality of the expression.
`InstructionInfo` | `getInstructionInfo()` Get InstructionInfo for this expression
`int` | `getInstructionNameCode()` Get the name of this instruction (return 'xsl:attribute')
`ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
`int` | `getValidationAction()`
`void` | `localTypeCheck(StaticContext env, ItemType contextItemType)` Method to perform type-checking specific to the kind of instruction
`TailCall` | `processLeavingTail(XPathContext context)` Process this instruction
`void` | `setNoSpecialChars()` Indicate that the attribute value contains no special characters that might need escaping
`void` | `setRejectDuplicates()` Indicate that two attributes with the same name are not acceptable.
`void` | `setSelect(Expression select, Configuration config)` Set the expression defining the value of the attribute.

Methods inherited from class net.sf.saxon.instruct.SimpleNodeConstructor
`computeCardinality, computeSpecialProperties, createsNewNodes, expandChildren, getSelect, iterate, iterateSubExpressions, optimize, replaceSubExpression, simplify, typeCheck`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, evaluateAsString, getImplementationMethod, getSourceLocator, isXSLT, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### FixedAttribute

    public FixedAttribute(int nameCode,
                          int validationAction,
                          SimpleType schemaType,
                          int annotation)

  Construct an Attribute instruction

  Parameters:
    `nameCode` - Represents the attribute name
    `annotation` - Integer code identifying the type named in the `type` attribute of the instruction - zero if the attribute was not present

Method Detail

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction (return 'xsl:attribute')

  Overrides:
    `getInstructionNameCode` in class `Instruction`

### setRejectDuplicates

    public void setRejectDuplicates()

  Indicate that two attributes with the same name are not acceptable. (This option is set in XQuery, but not in XSLT)

### setNoSpecialChars

    public void setNoSpecialChars()

  Indicate that the attribute value contains no special characters that might need escaping

### setSelect

    public void setSelect(Expression select,
                          Configuration config)
                   throws StaticError

  Set the expression defining the value of the attribute. If this is a constant, and if validation against a schema type was requested, the validation is done immediately.

  Overrides:
    `setSelect` in class `SimpleNodeConstructor`
  Parameters:
    `select` - The expression defining the content of the attribute
    `config` -
  Throws:
    `StaticError` - if the expression is a constant, and validation is requested, and the constant doesn't match the required type.

### getInstructionInfo

    public InstructionInfo getInstructionInfo()

  Description copied from class: `Expression`
  Get InstructionInfo for this expression

  Specified by:
    `getInstructionInfo` in interface `InstructionInfoProvider`
  Overrides:
    `getInstructionInfo` in class `Instruction`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Description copied from class: `Instruction`
  Get the item type of the items returned by evaluating this instruction

  Overrides:
    `getItemType` in class `Instruction`
  Returns:
    the static item type of the instruction

### getCardinality

    public int getCardinality()

  Description copied from class: `Expression`
  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Overrides:
    `getCardinality` in class `Expression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### getValidationAction

    public int getValidationAction()

### localTypeCheck

    public void localTypeCheck(StaticContext env,
                               ItemType contextItemType)

  Description copied from class: `SimpleNodeConstructor`
  Method to perform type-checking specific to the kind of instruction

  Specified by:
    `localTypeCheck` in class `SimpleNodeConstructor`

### evaluateNameCode

    public int evaluateNameCode(XPathContext context)

  Overrides:
    `evaluateNameCode` in class `SimpleNodeConstructor`

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Overrides:
    `checkPermittedContents` in class `Expression`
  Throws:
    `XPathException`

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Process this instruction

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - the dynamic context of the transformation
  Returns:
    a TailCall to be executed by the caller, always null for this instruction
  Throws:
    `XPathException`

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Description copied from class: `SimpleNodeConstructor`
  Evaluate as an expression. We rely on the fact that when these instructions are generated by XQuery, there will always be a valueExpression to evaluate the content

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `SimpleNodeConstructor`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Display this instruction as an expression, for diagnostics

  Overrides:
    `display` in class `SimpleNodeConstructor`
  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.